#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf mtools-4.0.18.tar.bz2
    cd mtools-4.0.18
    bunzip2 -c ../mtools-4.0.15-dietpc-patch.bz2 | patch -p1 -b
    ./configure --prefix=/usr --sysconfdir=/etc --enable-floppyd
    make floppyd
    gcc -o floppyd floppyd.o llong.o -lX11 -lwrap
    strip -R .note -R .comment floppyd
    mkdir -p ../floppyd/sbin
    cp floppyd ../floppyd/sbin/
    cd ..
    rm -rf mtools-4.0.18
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
